# About
TSMPIPE is a Tivoli Storage Manager (TSM) or now known as Spectrum Protect client, that enables you to take data from STDIN and store that in TSM as a BACKUP or ARCHIVE object.
By using this client, you dont need to do a dump to disk process, followed by using the Spectrum Protect Backup Archive Client. (So no more consuming disk space with old dumps!)

Restoring data, is the reverse step, restoring direclty back to the application from Spectrum Protect.

# Using
In its simplest form, you can
```cat myfile.ext | tsmpipe -c [MORE OPTIONS]```

Or, where an application supports "dumping" to STDOUT, you can pipe that dump into TSMPIPE.
```myappdump | tsmpipe -c [OPTIONS]```

Getting data back is the reverse
```tsmpipe -x [MORE OPTIONS] > myfile```

Or, back to your application
```tsmpipe -x [MORE OPTIONS] | myapp```

This client can also calculate a digest while backuping up data (like MD5, SHA1, etc) - so that you can verify that the dump out of the application matches what goes into
Spectrum Protect. For example:

```
myappdump > file
md5sum file
cat file | tsmpipe -cBs /example/ -f file -m md5
tsmpipe -xBs /example/ -f file > file2
md5sum file2
```

The MD5 calculation should match in all cases - including the MD5 printed by tsmpipe. See the build test script for more details.

# Help
For help, use tsmpipe -h
To test that you can connect to TSM, use tsmpipe -i
